'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactSyntaxHighlighter = require('react-syntax-highlighter');

var _reactSyntaxHighlighter2 = _interopRequireDefault(_reactSyntaxHighlighter);

var _atomOneDark = require('react-syntax-highlighter/dist/styles/atom-one-dark');

var _atomOneDark2 = _interopRequireDefault(_atomOneDark);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var headerStyle = function headerStyle(width) {
  return {
    boxSizing: 'border-box',
    color: 'rgb(69, 45, 45)',
    textAlign: 'center',
    backgroundColor: 'rgb(225, 223, 225)',
    fontFamily: 'monaco, Consolas, Lucida Console, monospace',
    fontSize: 16,
    paddingBottom: 1,
    borderTopLeftRadius: 5,
    borderTopRightRadius: 5,
    width: width
  };
};

var buttonsContainer = {
  display: 'flex',
  justifyContent: 'space-between',
  position: 'absolute',
  left: 20,
  top: 5,
  width: 60
};

var buttonStyle = function buttonStyle(color) {
  return {
    width: 14,
    height: 14,
    borderRadius: '50%',
    backgroundColor: color
  };
};

var redButton = buttonStyle('rgb(252, 100, 95)');
var yellowButton = buttonStyle('rgb(253, 191, 65)');
var greenButton = buttonStyle('rgb(54, 206, 76)');

var CodeWindow = function (_React$Component) {
  _inherits(CodeWindow, _React$Component);

  function CodeWindow() {
    _classCallCheck(this, CodeWindow);

    var _this = _possibleConstructorReturn(this, (CodeWindow.__proto__ || Object.getPrototypeOf(CodeWindow)).call(this));

    _this.state = { minimized: false, showMinus: false };
    return _this;
  }

  _createClass(CodeWindow, [{
    key: 'render',
    value: function render() {
      var _this2 = this;

      var _props = this.props,
          _props$width = _props.width,
          width = _props$width === undefined ? 500 : _props$width,
          _props$title = _props.title,
          title = _props$title === undefined ? "react-code-window" : _props$title,
          children = _props.children;

      var yellowButtonChildren = this.state.showMinus ? _react2.default.createElement(
        'span',
        { style: {
            position: 'relative',
            bottom: '5px',
            fontWeight: 600,
            fontSize: 14,
            color: 'rgba(0,0,0,0.5)',
            cursor: 'default',
            highlight: 'none'
          } },
        '\u2212'
      ) : null;
      var greenButtonChildren = this.state.showMinus ? _react2.default.createElement(
        'span',
        { style: {
            position: 'relative',
            bottom: '5px',
            fontWeight: 600,
            fontSize: 12,
            color: 'rgba(0,0,0,0.5)',
            cursor: 'default',
            highlight: 'none'
          } },
        '+'
      ) : null;
      var syntax = !this.state.minimized ? _react2.default.createElement(
        _reactSyntaxHighlighter2.default,
        {
          style: _atomOneDark2.default,
          customStyle: {
            margin: 0,
            width: 'calc(' + (typeof width === 'number' ? width + 'px' : width) + ' - 1em)'
          }
        },
        children
      ) : null;
      return _react2.default.createElement(
        'div',
        { style: { position: 'relative', width: '100%' } },
        _react2.default.createElement(
          'div',
          { style: headerStyle(width) },
          _react2.default.createElement(
            'span',
            {
              style: buttonsContainer,
              onMouseEnter: function onMouseEnter() {
                return _this2.setState({ showMinus: true });
              },
              onMouseLeave: function onMouseLeave() {
                return _this2.setState({ showMinus: false });
              }
            },
            _react2.default.createElement('div', { style: redButton }),
            _react2.default.createElement(
              'div',
              {
                style: yellowButton,
                onClick: function onClick() {
                  return _this2.setState({ minimized: true });
                }
              },
              yellowButtonChildren
            ),
            _react2.default.createElement(
              'div',
              {
                style: greenButton,
                onClick: function onClick() {
                  return _this2.setState({ minimized: false });
                }
              },
              greenButtonChildren
            )
          ),
          title
        ),
        syntax
      );
    }
  }]);

  return CodeWindow;
}(_react2.default.Component);

exports.default = CodeWindow;